	PROGRAM tpikl
	IMPLICIT  REAL*8(A-H,O-Z)	
	PARAMETER N=100,M=500
	DIMENSION REZU1(0:N),REZU2(0:M),REZV1(0:N),REZV2(0:M)	
	DIMENSION U0(0:N,0:M),V0(0:N,0:M)
	DIMENSION U1(0:N,0:M),V1(0:N,0:M)
	DIMENSION U2(0:N,0:M),V2(0:N,0:M)
	DIMENSION X(0:5000),Z1(0:5000),Z2(0:5000)
	DIMENSION TUR(0:5,0:100000),TVR(0:5,0:100000)
		
    DIMENSION AU1(1:N-1),BU1(1:N-1),FU1(1:N-1)
	DIMENSION AU2(1:M-1),BU2(1:M-1),FU2(1:M-1)
	DIMENSION AV1(1:N-1),BV1(1:N-1),FV1(1:N-1)
	DIMENSION AV2(1:M-1),BV2(1:M-1),FV2(1:M-1)
     	  	
    !block data  ----------------
	    A1=1.5D-1	  !k_e
		A2=2.327D-4   !k_i
		A3=1.481D+1	  !g_e
		A4=0.103D0    !g_i
		A01=8.96D+6   !A_0e
		A02=88.51D0   !A_0i

        R_max=0.5d0
        Z_max=200.d0 
		
		t_0=1.d-13  
		HT=1.D-5
	    HR=R_max/DFLOAT(N)   
	    HZ=Z_max/DFLOAT(M)
		 
		 OPEN(UNIT=1,FILE='MUZ.TXT')
	        DO J=0,M
		      READ(1,*) X(J),Z1(J),Z2(J)
			END DO
		 CLOSE(1) 
	!----------------------------
		
		  HR2=HR*HR
		  HZ2=HZ*HZ
		  HR100=100.D0*HR
			
		  HR2DHZ2=HR2/HZ2
		  HR2DA1HT=2.0D0*HR2/A1/HT
		  HR2DA2HT=2.0D0*HR2/A2/HT
		  HR2DA1=HR2/A1
		  HR2DA2=HR2/A2 
		  HR2A3DA1=HR2*A3/A1
		  HR2A4DA2=HR2*A4/A2

		  HZ2DHR2=HZ2/HR2
		  HZ2DA1HT=2.0D0*HZ2/A1/HT
		  HZ2DA2HT=2.0D0*HZ2/A2/HT
		  HZ2DA1=HZ2/A1
		  HZ2DA2=HZ2/A2
		  HZ2A3DA1=HZ2*A3/A1
		  HZ2A4DA2=HZ2*A4/A2

	   CU1=2.0D0+HR2DA1HT
       CU2=2.0D0+HZ2DA1HT
	   CV1=2.0D0+HR2DA2HT
       CV2=2.0D0+HZ2DA2HT

	   DO I=1,N-1
	     AU1(I)=1.0D0-1.0D0/DFLOAT(2*I)
	     BU1(I)=1.0D0+1.0D0/DFLOAT(2*I)
		 AV1(I)=1.0D0-1.0D0/DFLOAT(2*I)
		 BV1(I)=1.0D0+1.0D0/DFLOAT(2*I)
	   END DO

	   DO J=1,M-1
	     AU2(J)=1.0D0
		 BU2(J)=1.0D0
		 AV2(J)=1.0D0
		 BV2(J)=1.0D0
	   END DO

	    AMU1=0
		AMU2=0
		AKP1=1.D0
	    AKP2=0.D0


        ! nachalnoy uslovie
	    DO I=0,N
		 DO J=0,M
		  U0(I,J)=0.0D0
		  V0(I,J)=0.0D0
         END DO
		END DO

		 
		 		
			DO J=0,M
		      Z1(J)=A01*Z1(J)
			  Z2(J)=A02*Z2(J)
			END DO
		 
		
		 t_k=0.1
		 KK=int(t_k/HT)	  	  
	     K1=KK/100		
         
		!=======================================
		!nachalo iteracii po vremeni
		 DO K=0,KK
		    ZK=HT*(DFLOAT(K)+0.0D0)-0.05D0
		    ZZK=DEXP(-5000.0D0*ZK*ZK) 

        !nachalo iteraci po z
		  DO J=1,M-1
		    ZZKZ1=ZZK*Z1(J)
			ZZKZ2=ZZK*Z2(J)
          !opredeleni progonochnikh koefficientov po r
           DO I=1,N-1
             HDEXP=DEXP(-HR100*DFLOAT(I))
		     ACU1=HDEXP*ZZKZ1
			 ACV1=HDEXP*ZZKZ2     
		
		     HHZU=HR2DHZ2*(U0(I,J+1)-2.0D0*U0(I,J)+U0(I,J-1))
			 HHGU1=HR2A3DA1*(U0(I,J)-V0(I,J))
			 FU1(I)=HR2DA1HT*U0(I,J)+HHZU-HHGU1+HR2DA1*ACU1
		   
		 !=======================================
			
			 HHZV=HR2DHZ2*(V0(I,J+1)-2.0D0*V0(I,J)+V0(I,J-1))
			 HHGV1=HR2A4DA2*(U0(I,J)-V0(I,J))
			 FV1(I)=HR2DA2HT*V0(I,J)+HHZV+HHGV1+HR2DA2*ACV1
		   END DO
		      
			  AMU_U1=-FU1(1)/(AU1(1)-3.D0*BU1(1))
			  AKP_U1=(CU1-4.D0*BU1(1))/(AU1(1)-3.D0*BU1(1))

			  AMU_V1=-FV1(1)/(AV1(1)-3.D0*BV1(1))
			  AKP_V1=(CV1-4.D0*BV1(1))/(AV1(1)-3.D0*BV1(1))
			  	
              CALL PROGONKA(N,AU1,BU1,CU1,FU1,AMU_U1,AMU2,AKP_U1,AKP2,REZU1)
			  CALL PROGONKA(N,AV1,BV1,CV1,FV1,AMU_V1,AMU2,AKP_V1,AKP2,REZV1)
			
			DO I=0,N	    
			 U1(I,J)=REZU1(I)
             V1(I,J)=REZV1(I)            
			END DO
	
          END DO
		  	
		   !vichisleniy granichniy tochek
			DO I=0,N			 			 
             U1(I,0)=(4.0D0*U1(I,1)-U1(I,2))/3.0D0
             V1(I,0)=(4.0D0*V1(I,1)-V1(I,2))/3.0D0
	         U1(I,M)=0
             V1(I,M)=0
			END DO
             ! ZK1=HT*DFLOAT(K)-0.05D0
			 ZK1=HT*(DFLOAT(K)+0.5D0)-0.05D0
		     ZZK1=DEXP(-5000.0D0*ZK1*ZK1)
       
	   !nachalo iteraci po r
		  DO I=1,N-1
		   HDZZK=DEXP(-HR100*DFLOAT(I))*ZZK1
		 !opredeleni progonochnikh koefficientov po z
           DO J=1,M-1
            
		     ACU2=HDZZK*Z1(J)
			 ACV2=HDZZK*Z2(J)
		     
		     HHRU=HZ2DHR2*(BU1(I)*U1(I+1,J)-2.0D0*U1(I,J)+AU1(I)*U1(I-1,J))
			 HHGU2=HZ2A3DA1*(U1(I,J)-V1(I,J))
			 FU2(J)=HZ2DA1HT*U1(I,J)+HHRU-HHGU2+HZ2DA1*ACU2
		
		!=======================================

	         HHRV=HZ2DHR2*(BV1(I)*V1(I+1,J)-2.0D0*V1(I,J)+AV1(I)*V1(I-1,J))
			 HHGV2=HZ2A4DA2*(U1(I,J)-V1(I,J))
			 FV2(J)=HZ2DA2HT*V1(I,J)+HHRV+HHGV2+HZ2DA2*ACV2

		   END DO

		      AMU_U2=-FU2(1)/(AU2(1)-3.D0*BU2(1))
			  AKP_U2=(CU2-4.D0*BU2(1))/(AU2(1)-3.D0*BU2(1))

			  AMU_V2=-FV2(1)/(AV2(1)-3.D0*BV2(1))
			  AKP_V2=(CV2-4.D0*BV2(1))/(AV2(1)-3.D0*BV2(1))

              CALL PROGONKA(M,AU2,BU2,CU2,FU2,AMU_U2,AMU2,AKP_U2,AKP2,REZU2)
			  CALL PROGONKA(M,AV2,BV2,CV2,FV2,AMU_V2,AMU2,AKP_V2,AKP2,REZV2)
	      
		   DO J=0,M			
			 U2(I,J)=REZU2(J)
             V2(I,J)=REZV2(J)
			END DO
          END DO	   
		
		!vichisleniy granichniy tochek 
			DO J=0,M 			
			 U2(0,J)=(4.0D0*U2(1,J)-U2(2,J))/3.0D0
             V2(0,J)=(4.0D0*V2(1,J)-V2(2,J))/3.0D0
			 U2(N,J)=0
             V2(N,J)=0
			END DO
		

	         DO I=0,N
			  DO J=0,M
               U0(I,J)=U2(I,J)
			   V0(I,J)=V2(I,J)
			  END DO
			 END DO

   !copy results----------------------
   !sokhraneniy rezltatov po vremeni v raznix glubinakh po z-0,2,4 mkm
   	     
              TUR(0,K)=U0(0,0)
			  TUR(1,K)=U0(0,50)
			  TUR(2,K)=U0(0,100)
			  TVR(0,K)=V0(0,0)
			  TVR(1,K)=V0(0,50)
			  TVR(2,K)=V0(0,100)		
   !----------------------------------		         		   
			
			PRINT*,K
		END DO
   !save results------------------
   ! v fayle tur.txt temperatura elektronov v Kelvinahk
   ! v fayle tvr.txt temperatura reshetki v Kelvinahk
	 OPEN(UNIT=4,FILE='TUR.TXT')  
	  DO K=0,KK
	   WRITE(4,'(4E24.15)') HT*DFLOAT(K)*t_0,(300.d0*(TUR(I,K)+1.d0),I=0,2) 
	  END DO
	 CLOSE(4)

	  OPEN(UNIT=5,FILE='TVR.TXT')
	  DO K=0,KK
	   WRITE(5,'(4E24.15)') HT*DFLOAT(K)*t_0,(300.d0*(TVR(I,K)+1.d0),I=0,2) 
	  END DO
	 CLOSE(5)

   !------------------------------

   
	END


subroutine progonka(nn,A,B,diag,prav,mu1,mu2,kp1,kp2,rez)
implicit none
integer::i
integer,intent(in)::nn
real*8,intent(in)::diag,mu1,mu2,kp1,kp2
real*8,dimension(1:nn)::alpha,betta
real*8,dimension(1:nn-1),intent(in)::A,B,prav
real*8,dimension(0:nn),intent(out)::rez
real*8 hlp1

alpha(1)=kp1
betta(1)=mu1

   do i=1,nn-1
	hlp1=diag-A(I)*alpha(i)
	alpha(i+1)=B(I)/hlp1
	betta(i+1)=(prav(i)+A(I)*betta(i))/hlp1
   enddo

rez(nn)=(mu2+kp2*betta(nn))/(1.d0-alpha(nn)*kp2)

do i=nn-1,0,-1
	rez(i)=alpha(i+1)*rez(i+1)+betta(i+1)
enddo

end subroutine progonka 
